# Generated by Django 4.2.3 on 2025-01-27 20:33

import apps.invitations.models
import colmena.validators.validators
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):
    dependencies = [
        ("organizations", "0014_userteam_group"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ("auth", "0012_alter_user_first_name_max_length"),
        ("invitations", "0004_alter_administrationinvitation_options_and_more"),
    ]

    operations = [
        migrations.CreateModel(
            name="TeamInvitation",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "token",
                    models.CharField(
                        max_length=128,
                        validators=[
                            colmena.validators.validators.ValidatorOnlyLettersAndSpaces()
                        ],
                        verbose_name="invitations_prop_token",
                    ),
                ),
                (
                    "state",
                    models.CharField(
                        choices=[
                            ("PENDING", "Pending"),
                            ("SENT", "Sent"),
                            ("ACCEPTED", "Accepted"),
                            ("DELIVERY_FAILED", "Delivery failed"),
                        ],
                        default="PENDING",
                        max_length=32,
                        verbose_name="invitations_prop_state",
                    ),
                ),
                (
                    "created_at",
                    models.DateTimeField(
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name="created_at",
                    ),
                ),
                (
                    "updated_at",
                    models.DateTimeField(
                        default=django.utils.timezone.now, verbose_name="updated_at"
                    ),
                ),
                (
                    "group",
                    models.ForeignKey(
                        default=apps.invitations.models.get_default_group,
                        limit_choices_to={
                            "name__in": ["TeamAdmin", "TeamCollaborator"]
                        },
                        on_delete=django.db.models.deletion.CASCADE,
                        to="auth.group",
                    ),
                ),
                (
                    "invited_by",
                    models.ForeignKey(
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        related_name="%(class)s_from_user",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="invitations_prop_invited_by",
                    ),
                ),
                (
                    "team",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="team_invitation_team",
                        to="organizations.team",
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="%(class)s_user",
                        to=settings.AUTH_USER_MODEL,
                        verbose_name="invitations_prop_user",
                    ),
                ),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
